package com.freshcodes.red5pro;

import android.content.Context;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.red5pro.streaming.R5StreamProtocol;
import com.red5pro.streaming.config.R5Configuration;

import java.util.Map;

import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.StandardMessageCodec;
import io.flutter.plugin.platform.PlatformView;
import io.flutter.plugin.platform.PlatformViewFactory;

public class Red5StreamViewFactory extends PlatformViewFactory {
    @NonNull
    private final BinaryMessenger messenger;

    Red5StreamViewFactory(@NonNull BinaryMessenger messenger) {
        super(StandardMessageCodec.INSTANCE);
        this.messenger = messenger;
    }

    @NonNull
    @Override
    public PlatformView create(@NonNull Context context, int id, @Nullable Object args) {
        final Map<String, Object> creationParams = (Map<String, Object>) args;
        Map<String, Object> configuration = (Map<String, Object>) creationParams.get("configuration");
        String licenseKey = (String) configuration.get("licenseKey");
        int protocol = (int) configuration.get("protocol");
        String host = (String) configuration.get("host");
        int port = (int) configuration.get("port");
        String contextName = (String) configuration.get("contextName");
        float bufferTime = ((Double) configuration.get("bufferTime")).floatValue();
        R5Configuration r5Configuration = new R5Configuration(AppUtility.intToR5StreamProtocol(protocol), host, port, contextName, bufferTime);
        r5Configuration.setLicenseKey(licenseKey);

        int height = (int) creationParams.get("height");
        int width = (int) creationParams.get("width");

        int bitrate = (int) creationParams.get("bitrate");
        int fps = (int) creationParams.get("fps");

        return new Red5StreamView(context, messenger, id, r5Configuration, height, width, bitrate, fps);
    }
}
